package solutions.bitbadger.documents.java.java.integration.postgresql;

import org.junit.jupiter.api.DisplayName;
import org.junit.jupiter.api.Test;
import solutions.bitbadger.documents.java.integration.postgresql.PgDB;
import solutions.bitbadger.documents.java.java.integration.common.CountFunctions;

/**
 * PostgreSQL integration tests for the `Count` object / `count*` connection extension functions
 */
@DisplayName("Java | Java | PostgreSQL: Count")
public class CountIT {

    @Test
    @DisplayName("all counts all documents")
    public void all() {
        try (PgDB db = new PgDB()) {
            CountFunctions.all(db);
        }
    }

    @Test
    @DisplayName("byFields counts documents by a numeric value")
    public void byFieldsNumeric() {
        try (PgDB db = new PgDB()) {
            CountFunctions.byFieldsNumeric(db);
        }
    }

    @Test
    @DisplayName("byFields counts documents by a alphanumeric value")
    public void byFieldsAlpha() {
        try (PgDB db = new PgDB()) {
            CountFunctions.byFieldsAlpha(db);
        }
    }

    @Test
    @DisplayName("byContains counts documents when matches are found")
    public void byContainsMatch() {
        try (PgDB db = new PgDB()) {
            CountFunctions.byContainsMatch(db);
        }
    }

    @Test
    @DisplayName("byContains counts documents when no matches are found")
    public void byContainsNoMatch() {
        try (PgDB db = new PgDB()) {
            CountFunctions.byContainsNoMatch(db);
        }
    }

    @Test
    @DisplayName("byJsonPath counts documents when matches are found")
    public void byJsonPathMatch() {
        try (PgDB db = new PgDB()) {
            CountFunctions.byJsonPathMatch(db);
        }
    }

    @Test
    @DisplayName("byJsonPath counts documents when no matches are found")
    public void byJsonPathNoMatch() {
        try (PgDB db = new PgDB()) {
            CountFunctions.byJsonPathNoMatch(db);
        }
    }
}
