package solutions.bitbadger.documents.java

import solutions.bitbadger.documents.DocumentSerializer
import com.fasterxml.jackson.databind.ObjectMapper

/**
 * A JSON serializer using Jackson's default options
 */
class JacksonDocumentSerializer : DocumentSerializer {

    val mapper = ObjectMapper()

    override fun <TDoc> serialize(document: TDoc) =
        mapper.writeValueAsString(document)

    override fun <TDoc> deserialize(json: String, clazz: Class<TDoc>) =
        mapper.readValue(json, clazz)
}
